/*
 * Copyright (c) 2014 by David I. Bell
 * Permission is granted to use, distribute, or modify this source,
 * provided that this copyright notice remains intact.
 *
 * Public prototypes.
 */

#ifndef	DPY_H
#define	DPY_H

/*
 * The version of the dpy library.
 */
#define	DPYVERSION	"3.2"


/*
 * Special return values from dpyinputchar.
 * These values are all negative.
 */
#define	DPYEOF		-1	/* read end of file */
#define	DPYINTR		-2	/* read was interrupted */
#define	DPYERROR	-3	/* read got another error */


/*
 * The dpy functions themselves.
 */
extern int	dpyinit(const char * ttyType, const char * modeString);
extern int	dpywindow(int minRow, int maxRow, int minCol, int maxCol);
extern int	dpyread (const char *, int (*routine)(int), char *, int, int);
extern int	dpytestinput(void);
extern int	dpyinputchar(void);
extern int	dpymove(int row, int col);
extern int	dpyplace(int row, int col, int ch);
extern int	dpywrite(const char * buf, int count);
extern int	dpyprintf(const char * fmt, ...);
extern int	dpychar(int ch);
extern int	dpystr(const char * str);
extern int	dpyget(int row, int col);
extern void	dpyclrline(void);
extern void	dpyclrwindow(void);
extern void	dpyhome(void);
extern int	dpygetrow(void);
extern int	dpygetcol(void);
extern void	dpyupdate(void);
extern void	dpyredraw(void);
extern void	dpystop(void);
extern int	dpysave(char ** ptr);
extern int	dpyrestore(const char * ptr);
extern void	dpyclose(void);

#endif
