/*
 * Copyright (c) 2014 by David I. Bell
 * Permission is granted to use, distribute, or modify this source,
 * provided that this copyright notice remains intact.
 */

#include "dpy_priv.h"


/*
 * This should be replaced by a machine level routine if possible.
 * Compare two strings of a given length, and return the number of leading
 * bytes which are identical, or the length if the strings are identical.
 * Nulls are not treated specially.  Examples:
 *	dpyStrDif("hi mom", "hi pop", 6) returns 3.
 *	dpyStrDif("aaaa1", "aaaa2", 2) returns 2.
 */
int
dpyStrDif(const char * s1, const char * s2, int len)
{
	const char * beg = s1;		/* beginning character */
	const char * end = s1 + len;	/* ending character */

	while ((s1 < end) && (*s1 == *s2))
	{
		s1++;
		s2++;
	}

	return s1 - beg;
}

/* END CODE */
