/*
 * Example program.  Randomly fill up the screen with numbers until
 * it all turns to asterisks and occasionally pop up a screen to show
 * the status.
 */

#include <unistd.h>
#include <stdlib.h>

#include <dpy.h>


int
main(int argc, const char ** argv)
{
	int row;
	int col;
	int ch;
	int rows;
	int cols;
	int leftCount;
	int checkCount = 0;
	int changeCount = 0;
	char * saveData = 0;

	if (dpyinit(0, "e"))
		return 1;

	dpymove(-1, -1);

	rows = dpygetrow() + 1;
	cols = dpygetcol() + 1;

	leftCount = rows * cols * 10;

	dpyhome();
	dpyupdate();

	sleep(1);

	do
	{
		row = random() % rows;
		col = random() % cols;

		ch = dpyget(row, col);

		changeCount++;
		leftCount--;

		if (ch == ' ')
			ch = '1';
		else if (ch == '9')
			ch = '*';
		else if (ch != '*')
			ch++;
		else
		{
			leftCount++;
			changeCount--;
		}

		dpyplace(row, col, ch);

		if ((++checkCount % 1000) == 0)
		{
			if (dpysave(&saveData) < 0)
				continue;

			dpyupdate();

			sleep(1);

			dpywindow(rows / 3, (rows / 3) + 6,
				cols / 3, (cols / 3) + 35);

			dpyprintf("\n\n"
				"    Total checks: %d\n"
				"    Changes this update: %d\n"
				"    Changes left to make: %d\n",
				checkCount, changeCount, leftCount);

			dpyclrwindow();

			dpywindow(0, -1, 0, -1);
			dpyupdate();

			sleep(1);

			dpyrestore(saveData);

			changeCount = 0;
		}

		dpyupdate();
	}
	while ((leftCount > 0) || (changeCount > 0) || (checkCount % 1000));

	sleep(1);

	dpyclose();

	return 0;
}
